#include <windows.h>

char *pszIncoming[80]; //global, used for LoadSettings()

/////// following functions are REQUIRED. If you omit one of these, the program and/or the
/////// plug-in will not operate normally and is even likely to CRASH. And we don't want that
/////// to happen, do we?

char* DLLName(void) {
	return "Programmers example plug-in";  //ALL strings are ZERO TERMINATED (which is normal, in C)
}

int NumberOfHotkeys(void) {
	return 2;	//2 hotkeys defined in this plug-in. The first hotkey has number 0 (zero)!!
}

void DefaultHotkey(int iHotkeyNr, int &iVkCode, int &iMod) {
	switch (iHotkeyNr) {
		case 0:
			iVkCode='4';  //Virtual Key Code
			iMod=MOD_CONTROL; //there are 3: MOD_CONTROL, MOD_ALT, MOD_SHIFT. To combine them, use OR (|)
			return;
		case 1:
			iVkCode='5';
			iMod=MOD_CONTROL;
			return;
	}
}

char* HotkeyName(int iHotkeyNr) {
	switch (iHotkeyNr) {
		case 0:
			return "put Example 1 on screen";
		default:	//should be case 1:, but that results in a warning from the compiler. No problem though.
			return "put Example 2 on screen";
	}
}

void HotkeyPressed(int iHotkeyNr) {
	switch (iHotkeyNr) {
		case 0:	//here is the first hotkey handled
			MessageBox(NULL,"This is Example Hotkey 1","It worked!",MB_ICONINFORMATION);
			return;
		case 1:	//and the second hotkey
			MessageBox(NULL,"This is Example Hotkey 2","It worked!",MB_ICONINFORMATION);
			return;
	}
}


int DLLSpecVersion(int iDKVersion) {
	if (iDKVersion<1)
		return 0;  //return 0 if the version of the control panel is too old.
	else
		return 1; //otherwise, return the version for which this plug-in is written.
}

/////// following functions are NOT required. If you don't need a specific function,
/////// just omit the function in your Plug-in.

BOOL LoadSettings(int iNumber, char *&pszKey,char *&pszValue, int &iValueSize) {
	pszKey="Example";	//this is the keyname. The value after this keyname is stored in pszValue
	pszValue=(char*)pszIncoming;  //psazIncoming must be available outside this function. It's global here.
	iValueSize=80;	//size of array
	return FALSE;	//no more things to load after this one. Return TRUE if there are more thing to load.
}

BOOL SaveSettings(int iNumber, char *&pszKey,char *&pszValue) {
	pszKey="Example";	//store the folowing data in the key "Example"
	pszValue="This text is saved in DreamKeys.ini";	//the data to be stored
	return FALSE;	////no more things to save after this one. Return TRUE if there are more thing to save.
}

char* MoreInfo(void) {
	return "An example plug-in for programmers. The source of this plug-in is freely available at out webpage.\n1999 Digital Dreams Software";
}

BOOL AcceptAuto(void) {
	return TRUE;	//if returned FALSE, a warning is issued when user sets this plug-in to auto. Default is TRUE.
}

void Config(void) {

	//you can do here whatever you want, as long as it has something to do with the plug-in :-)
	MessageBox(NULL,"Normally, a configuration dialog for the Plug-in is displayed now. This is just an example","Config button pressed",MB_ICONINFORMATION);
}